
/************************************************************************
 *
 * File: Vector3.cc
 *
 * Copyright (c) 1995 by Rensselaer Polytechnic Institute,
 *                       Troy, NY 12180
 *
 * Created:       Thu Oct  5 10:56:16 1995 by James Miller
 * Last Modified: Fri Nov  3 10:53:14 1995 by James Miller
 *
 * A 3D vector.
 *
 ************************************************************************/

#ident "@(#)Vector3.cc	1.1 95/11/09 RPI"

#include "Vector3.h"

Vector3::~Vector3()
{
}


Vector3 Vector3::operator+(const Vector3& vec) const
{
    Vector3 ret(*this);

    ret += vec;

    return ret;
}


Vector3 Vector3::operator-(const Vector3& vec) const
{
    Vector3 ret(*this);

    ret -= vec;

    return ret;
}

Vector3 Vector3::operator-() const
{
    Vector3 ret(-xval, -yval, -zval);

    return ret;
}


// cross product
Vector3 Vector3::operator%(const Vector3& vec) const
{
    Vector3 ret;

    ret.xval = yval*vec.zval - vec.yval*zval;
    ret.yval = vec.xval*zval - xval*vec.zval;
    ret.zval = xval*vec.yval - vec.xval*yval;

    return ret;
}


//
// scalar operators
//


Vector3 Vector3::operator*(double scale) const
{
    Vector3 ret(scale*xval, scale*yval, scale*zval);

    return ret;
}

Vector3 Vector3::operator/(double scale) const
{
    Vector3 ret(xval/scale, yval/scale, zval/scale);

    return ret;
}


